<?php
if (!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED !== true) die();

use Bitrix\Main\Loader;
use Bitrix\Main\UserTable;
use Bitrix\Iblock\SectionTable;
use Bitrix\Iblock\PropertyTable;
use Bitrix\Iblock\PropertyEnumerationTable;
use Bitrix\Iblock\ElementTable;
// use Bitrix\Catalog\Model\Price;

// use Bitrix\Main\Mail\Event;

if (!Loader::includeModule('iblock'))
    die ('Модуль iblock не подключен');
if (!Loader::includeModule('catalog'))
    die ('Модуль catalog не подключен');


class Bulletin_form_new extends CBitrixComponent
{

   // private $properties = []; // Свойства для передачи между методами


    // Подготовка параметров компонента
    public function onPrepareComponentParams($arParams)
    {
        // todo хз надо ли оно тут
        return $arParams;
    }


    // Информация о пользователе ========================================
    protected function getUser()
    {
        return UserTable::getList([
            'filter' => ['ID' => $this->arParams['USER_ID']],
            'select' => ['*']
        ])->fetch();
    }


    // Получение разделов  ==============================================
    protected function getSections($parentId = null)
    { // todo преиспользовать этот метод в getElement
        $filter['IBLOCK_ID'] = $this->arParams['IBLOCK_ID'];
        if ($parentId == null) {
            $filter['DEPTH_LEVEL'] = 1;
        } else {
            $filter['=IBLOCK_SECTION_ID'] = $parentId;
        }
        return SectionTable::getList([
            'filter' => $filter,
            'order' => [
                'NAME' => 'ASC'
            ],
            'select' => [
                'ID', 'NAME'
            ]
        ])->fetchAll();
    }

    // Свойства ==========================================================
    protected function getProperties()
    { // todo преиспользовать этот метод в getElement
        $properties = [];

        $rsProperties = PropertyTable::getList([
            'filter' => [
                'IBLOCK_ID' => $this->arParams['IBLOCK_ID']
            ],
            'select' => [
                'ID', 'NAME', 'CODE', 'PROPERTY_TYPE', 'MULTIPLE'
            ]
        ]);

        while ($property = $rsProperties->fetch()) {
            $properties[$property['CODE']] = $property;
            // Если свойство - это множественный список
            if ($property['PROPERTY_TYPE'] === 'L' && $property['MULTIPLE'] === 'Y') {
                $properties[$property['CODE']]['ENUM_VALUES'] = PropertyEnumerationTable::getList([
                    'filter' => [
                        'PROPERTY_ID' => $property['ID']
                    ],
                    'select' => [
                        'ID', 'VALUE'
                    ]
                ])->fetchAll();
            }
        }
       // $this->properties = $properties;
        return $properties;
    }


    // Получение редактируемого элемента =================================================
    protected function getElement($elementId)
    {
        $elementDatas = [];
        // Основные данные о элементе остальное в component.php
        // так как реиспользуемость тут не нужна
        $dbElement = ElementTable::getList([
            'filter' => [
                'IBLOCK_ID' => $this->arParams['IBLOCK_ID'],
                'ID' => $elementId
            ],
            'select' => [
                'ID', 'NAME', 'IBLOCK_SECTION_ID',
                'DETAIL_TEXT', 'DETAIL_PICTURE', 'CREATED_BY'
            ]
        ]);
        if ($arElement = $dbElement->fetch()) {
            $elementDatas = $arElement;
            // Добавить получение цены и картинок
        }

        return $elementDatas;
    }


    // редактирование или добавление элемента
    // В процессе
}
